<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>AbstractVerifier xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../apidocs/org/apache/http/conn/ssl/AbstractVerifier.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.conn.ssl;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> org.apache.http.annotation.Immutable;
<a class="jxr_linenumber" name="31" href="#31">31</a>  
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.util.InetAddressUtils;
<a class="jxr_linenumber" name="33" href="#33">33</a>  
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> java.io.InputStream;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> java.security.cert.Certificate;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> java.security.cert.CertificateParsingException;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> java.security.cert.X509Certificate;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> java.util.Arrays;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> java.util.Collection;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> java.util.Iterator;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> java.util.LinkedList;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> java.util.Locale;
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">import</strong> java.util.StringTokenizer;
<a class="jxr_linenumber" name="46" href="#46">46</a>  
<a class="jxr_linenumber" name="47" href="#47">47</a>  <strong class="jxr_keyword">import</strong> javax.net.ssl.SSLException;
<a class="jxr_linenumber" name="48" href="#48">48</a>  <strong class="jxr_keyword">import</strong> javax.net.ssl.SSLSession;
<a class="jxr_linenumber" name="49" href="#49">49</a>  <strong class="jxr_keyword">import</strong> javax.net.ssl.SSLSocket;
<a class="jxr_linenumber" name="50" href="#50">50</a>  
<a class="jxr_linenumber" name="51" href="#51">51</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="52" href="#52">52</a>  <em class="jxr_javadoccomment"> * Abstract base class for all standard {@link X509HostnameVerifier}</em>
<a class="jxr_linenumber" name="53" href="#53">53</a>  <em class="jxr_javadoccomment"> * implementations.</em>
<a class="jxr_linenumber" name="54" href="#54">54</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="55" href="#55">55</a>  <em class="jxr_javadoccomment"> * @since 4.0</em>
<a class="jxr_linenumber" name="56" href="#56">56</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="57" href="#57">57</a>  @Immutable
<a class="jxr_linenumber" name="58" href="#58">58</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">abstract</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/conn/ssl/AbstractVerifier.html">AbstractVerifier</a> <strong class="jxr_keyword">implements</strong> <a href="../../../../../org/apache/http/conn/ssl/X509HostnameVerifier.html">X509HostnameVerifier</a> {
<a class="jxr_linenumber" name="59" href="#59">59</a>  
<a class="jxr_linenumber" name="60" href="#60">60</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="61" href="#61">61</a>  <em class="jxr_javadoccomment">     * This contains a list of 2nd-level domains that aren't allowed to</em>
<a class="jxr_linenumber" name="62" href="#62">62</a>  <em class="jxr_javadoccomment">     * have wildcards when combined with country-codes.</em>
<a class="jxr_linenumber" name="63" href="#63">63</a>  <em class="jxr_javadoccomment">     * For example: [*.co.uk].</em>
<a class="jxr_linenumber" name="64" href="#64">64</a>  <em class="jxr_javadoccomment">     * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="65" href="#65">65</a>  <em class="jxr_javadoccomment">     * The [*.co.uk] problem is an interesting one.  Should we just hope</em>
<a class="jxr_linenumber" name="66" href="#66">66</a>  <em class="jxr_javadoccomment">     * that CA's would never foolishly allow such a certificate to happen?</em>
<a class="jxr_linenumber" name="67" href="#67">67</a>  <em class="jxr_javadoccomment">     * Looks like we're the only implementation guarding against this.</em>
<a class="jxr_linenumber" name="68" href="#68">68</a>  <em class="jxr_javadoccomment">     * Firefox, Curl, Sun Java 1.4, 5, 6 don't bother with this check.</em>
<a class="jxr_linenumber" name="69" href="#69">69</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="70" href="#70">70</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> String[] BAD_COUNTRY_2LDS =
<a class="jxr_linenumber" name="71" href="#71">71</a>            { <span class="jxr_string">"ac"</span>, <span class="jxr_string">"co"</span>, <span class="jxr_string">"com"</span>, <span class="jxr_string">"ed"</span>, <span class="jxr_string">"edu"</span>, <span class="jxr_string">"go"</span>, <span class="jxr_string">"gouv"</span>, <span class="jxr_string">"gov"</span>, <span class="jxr_string">"info"</span>,
<a class="jxr_linenumber" name="72" href="#72">72</a>              <span class="jxr_string">"lg"</span>, <span class="jxr_string">"ne"</span>, <span class="jxr_string">"net"</span>, <span class="jxr_string">"or"</span>, <span class="jxr_string">"org"</span> };
<a class="jxr_linenumber" name="73" href="#73">73</a>  
<a class="jxr_linenumber" name="74" href="#74">74</a>      <strong class="jxr_keyword">static</strong> {
<a class="jxr_linenumber" name="75" href="#75">75</a>          <em class="jxr_comment">// Just in case developer forgot to manually sort the array.  :-)</em>
<a class="jxr_linenumber" name="76" href="#76">76</a>          Arrays.sort(BAD_COUNTRY_2LDS);
<a class="jxr_linenumber" name="77" href="#77">77</a>      }
<a class="jxr_linenumber" name="78" href="#78">78</a>  
<a class="jxr_linenumber" name="79" href="#79">79</a>      <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/conn/ssl/AbstractVerifier.html">AbstractVerifier</a>() {
<a class="jxr_linenumber" name="80" href="#80">80</a>          <strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="81" href="#81">81</a>      }
<a class="jxr_linenumber" name="82" href="#82">82</a>  
<a class="jxr_linenumber" name="83" href="#83">83</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">void</strong> verify(String host, SSLSocket ssl)
<a class="jxr_linenumber" name="84" href="#84">84</a>            <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="85" href="#85">85</a>          <strong class="jxr_keyword">if</strong>(host == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="86" href="#86">86</a>              <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> NullPointerException(<span class="jxr_string">"host to verify is null"</span>);
<a class="jxr_linenumber" name="87" href="#87">87</a>          }
<a class="jxr_linenumber" name="88" href="#88">88</a>  
<a class="jxr_linenumber" name="89" href="#89">89</a>          SSLSession session = ssl.getSession();
<a class="jxr_linenumber" name="90" href="#90">90</a>          <strong class="jxr_keyword">if</strong>(session == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="91" href="#91">91</a>              <em class="jxr_comment">// In our experience this only happens under IBM 1.4.x when</em>
<a class="jxr_linenumber" name="92" href="#92">92</a>              <em class="jxr_comment">// spurious (unrelated) certificates show up in the server'</em>
<a class="jxr_linenumber" name="93" href="#93">93</a>              <em class="jxr_comment">// chain.  Hopefully this will unearth the real problem:</em>
<a class="jxr_linenumber" name="94" href="#94">94</a>              InputStream in = ssl.getInputStream();
<a class="jxr_linenumber" name="95" href="#95">95</a>              in.available();
<a class="jxr_linenumber" name="96" href="#96">96</a>              <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="97" href="#97">97</a>  <em class="jxr_comment">              If you're looking at the 2 lines of code above because</em>
<a class="jxr_linenumber" name="98" href="#98">98</a>  <em class="jxr_comment">              you're running into a problem, you probably have two</em>
<a class="jxr_linenumber" name="99" href="#99">99</a>  <em class="jxr_comment">              options:</em>
<a class="jxr_linenumber" name="100" href="#100">100</a> 
<a class="jxr_linenumber" name="101" href="#101">101</a> <em class="jxr_comment">                #1.  Clean up the certificate chain that your server</em>
<a class="jxr_linenumber" name="102" href="#102">102</a> <em class="jxr_comment">                     is presenting (e.g. edit "/etc/apache2/server.crt"</em>
<a class="jxr_linenumber" name="103" href="#103">103</a> <em class="jxr_comment">                     or wherever it is your server's certificate chain</em>
<a class="jxr_linenumber" name="104" href="#104">104</a> <em class="jxr_comment">                     is defined).</em>
<a class="jxr_linenumber" name="105" href="#105">105</a> 
<a class="jxr_linenumber" name="106" href="#106">106</a> <em class="jxr_comment">                                           OR</em>
<a class="jxr_linenumber" name="107" href="#107">107</a> 
<a class="jxr_linenumber" name="108" href="#108">108</a> <em class="jxr_comment">                #2.   Upgrade to an IBM 1.5.x or greater JVM, or switch</em>
<a class="jxr_linenumber" name="109" href="#109">109</a> <em class="jxr_comment">                      to a non-IBM JVM.</em>
<a class="jxr_linenumber" name="110" href="#110">110</a> <em class="jxr_comment">            */</em>
<a class="jxr_linenumber" name="111" href="#111">111</a> 
<a class="jxr_linenumber" name="112" href="#112">112</a>             <em class="jxr_comment">// If ssl.getInputStream().available() didn't cause an</em>
<a class="jxr_linenumber" name="113" href="#113">113</a>             <em class="jxr_comment">// exception, maybe at least now the session is available?</em>
<a class="jxr_linenumber" name="114" href="#114">114</a>             session = ssl.getSession();
<a class="jxr_linenumber" name="115" href="#115">115</a>             <strong class="jxr_keyword">if</strong>(session == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="116" href="#116">116</a>                 <em class="jxr_comment">// If it's still null, probably a startHandshake() will</em>
<a class="jxr_linenumber" name="117" href="#117">117</a>                 <em class="jxr_comment">// unearth the real problem.</em>
<a class="jxr_linenumber" name="118" href="#118">118</a>                 ssl.startHandshake();
<a class="jxr_linenumber" name="119" href="#119">119</a> 
<a class="jxr_linenumber" name="120" href="#120">120</a>                 <em class="jxr_comment">// Okay, if we still haven't managed to cause an exception,</em>
<a class="jxr_linenumber" name="121" href="#121">121</a>                 <em class="jxr_comment">// might as well go for the NPE.  Or maybe we're okay now?</em>
<a class="jxr_linenumber" name="122" href="#122">122</a>                 session = ssl.getSession();
<a class="jxr_linenumber" name="123" href="#123">123</a>             }
<a class="jxr_linenumber" name="124" href="#124">124</a>         }
<a class="jxr_linenumber" name="125" href="#125">125</a> 
<a class="jxr_linenumber" name="126" href="#126">126</a>         Certificate[] certs = session.getPeerCertificates();
<a class="jxr_linenumber" name="127" href="#127">127</a>         X509Certificate x509 = (X509Certificate) certs[0];
<a class="jxr_linenumber" name="128" href="#128">128</a>         verify(host, x509);
<a class="jxr_linenumber" name="129" href="#129">129</a>     }
<a class="jxr_linenumber" name="130" href="#130">130</a> 
<a class="jxr_linenumber" name="131" href="#131">131</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong> verify(String host, SSLSession session) {
<a class="jxr_linenumber" name="132" href="#132">132</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="133" href="#133">133</a>             Certificate[] certs = session.getPeerCertificates();
<a class="jxr_linenumber" name="134" href="#134">134</a>             X509Certificate x509 = (X509Certificate) certs[0];
<a class="jxr_linenumber" name="135" href="#135">135</a>             verify(host, x509);
<a class="jxr_linenumber" name="136" href="#136">136</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="137" href="#137">137</a>         }
<a class="jxr_linenumber" name="138" href="#138">138</a>         <strong class="jxr_keyword">catch</strong>(SSLException e) {
<a class="jxr_linenumber" name="139" href="#139">139</a>             <strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="140" href="#140">140</a>         }
<a class="jxr_linenumber" name="141" href="#141">141</a>     }
<a class="jxr_linenumber" name="142" href="#142">142</a> 
<a class="jxr_linenumber" name="143" href="#143">143</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">void</strong> verify(String host, X509Certificate cert)
<a class="jxr_linenumber" name="144" href="#144">144</a>           <strong class="jxr_keyword">throws</strong> SSLException {
<a class="jxr_linenumber" name="145" href="#145">145</a>         String[] cns = getCNs(cert);
<a class="jxr_linenumber" name="146" href="#146">146</a>         String[] subjectAlts = getSubjectAlts(cert, host);
<a class="jxr_linenumber" name="147" href="#147">147</a>         verify(host, cns, subjectAlts);
<a class="jxr_linenumber" name="148" href="#148">148</a>     }
<a class="jxr_linenumber" name="149" href="#149">149</a> 
<a class="jxr_linenumber" name="150" href="#150">150</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">void</strong> verify(<strong class="jxr_keyword">final</strong> String host, <strong class="jxr_keyword">final</strong> String[] cns,
<a class="jxr_linenumber" name="151" href="#151">151</a>                              <strong class="jxr_keyword">final</strong> String[] subjectAlts,
<a class="jxr_linenumber" name="152" href="#152">152</a>                              <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">boolean</strong> strictWithSubDomains)
<a class="jxr_linenumber" name="153" href="#153">153</a>           <strong class="jxr_keyword">throws</strong> SSLException {
<a class="jxr_linenumber" name="154" href="#154">154</a> 
<a class="jxr_linenumber" name="155" href="#155">155</a>         <em class="jxr_comment">// Build the list of names we're going to check.  Our DEFAULT and</em>
<a class="jxr_linenumber" name="156" href="#156">156</a>         <em class="jxr_comment">// STRICT implementations of the HostnameVerifier only use the</em>
<a class="jxr_linenumber" name="157" href="#157">157</a>         <em class="jxr_comment">// first CN provided.  All other CNs are ignored.</em>
<a class="jxr_linenumber" name="158" href="#158">158</a>         <em class="jxr_comment">// (Firefox, wget, curl, Sun Java 1.4, 5, 6 all work this way).</em>
<a class="jxr_linenumber" name="159" href="#159">159</a>         LinkedList&lt;String&gt; names = <strong class="jxr_keyword">new</strong> LinkedList&lt;String&gt;();
<a class="jxr_linenumber" name="160" href="#160">160</a>         <strong class="jxr_keyword">if</strong>(cns != <strong class="jxr_keyword">null</strong> &amp;&amp; cns.length &gt; 0 &amp;&amp; cns[0] != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="161" href="#161">161</a>             names.add(cns[0]);
<a class="jxr_linenumber" name="162" href="#162">162</a>         }
<a class="jxr_linenumber" name="163" href="#163">163</a>         <strong class="jxr_keyword">if</strong>(subjectAlts != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="164" href="#164">164</a>             <strong class="jxr_keyword">for</strong> (String subjectAlt : subjectAlts) {
<a class="jxr_linenumber" name="165" href="#165">165</a>                 <strong class="jxr_keyword">if</strong> (subjectAlt != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="166" href="#166">166</a>                     names.add(subjectAlt);
<a class="jxr_linenumber" name="167" href="#167">167</a>                 }
<a class="jxr_linenumber" name="168" href="#168">168</a>             }
<a class="jxr_linenumber" name="169" href="#169">169</a>         }
<a class="jxr_linenumber" name="170" href="#170">170</a> 
<a class="jxr_linenumber" name="171" href="#171">171</a>         <strong class="jxr_keyword">if</strong>(names.isEmpty()) {
<a class="jxr_linenumber" name="172" href="#172">172</a>             String msg = <span class="jxr_string">"Certificate for &lt;"</span> + host + <span class="jxr_string">"&gt; doesn't contain CN or DNS subjectAlt"</span>;
<a class="jxr_linenumber" name="173" href="#173">173</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> SSLException(msg);
<a class="jxr_linenumber" name="174" href="#174">174</a>         }
<a class="jxr_linenumber" name="175" href="#175">175</a> 
<a class="jxr_linenumber" name="176" href="#176">176</a>         <em class="jxr_comment">// StringBuilder for building the error message.</em>
<a class="jxr_linenumber" name="177" href="#177">177</a>         StringBuilder buf = <strong class="jxr_keyword">new</strong> StringBuilder();
<a class="jxr_linenumber" name="178" href="#178">178</a> 
<a class="jxr_linenumber" name="179" href="#179">179</a>         <em class="jxr_comment">// We're can be case-insensitive when comparing the host we used to</em>
<a class="jxr_linenumber" name="180" href="#180">180</a>         <em class="jxr_comment">// establish the socket to the hostname in the certificate.</em>
<a class="jxr_linenumber" name="181" href="#181">181</a>         String hostName = host.trim().toLowerCase(Locale.US);
<a class="jxr_linenumber" name="182" href="#182">182</a>         <strong class="jxr_keyword">boolean</strong> match = false;
<a class="jxr_linenumber" name="183" href="#183">183</a>         <strong class="jxr_keyword">for</strong>(Iterator&lt;String&gt; it = names.iterator(); it.hasNext();) {
<a class="jxr_linenumber" name="184" href="#184">184</a>             <em class="jxr_comment">// Don't trim the CN, though!</em>
<a class="jxr_linenumber" name="185" href="#185">185</a>             String cn = it.next();
<a class="jxr_linenumber" name="186" href="#186">186</a>             cn = cn.toLowerCase(Locale.US);
<a class="jxr_linenumber" name="187" href="#187">187</a>             <em class="jxr_comment">// Store CN in StringBuilder in case we need to report an error.</em>
<a class="jxr_linenumber" name="188" href="#188">188</a>             buf.append(<span class="jxr_string">" &lt;"</span>);
<a class="jxr_linenumber" name="189" href="#189">189</a>             buf.append(cn);
<a class="jxr_linenumber" name="190" href="#190">190</a>             buf.append('&gt;');
<a class="jxr_linenumber" name="191" href="#191">191</a>             <strong class="jxr_keyword">if</strong>(it.hasNext()) {
<a class="jxr_linenumber" name="192" href="#192">192</a>                 buf.append(<span class="jxr_string">" OR"</span>);
<a class="jxr_linenumber" name="193" href="#193">193</a>             }
<a class="jxr_linenumber" name="194" href="#194">194</a> 
<a class="jxr_linenumber" name="195" href="#195">195</a>             <em class="jxr_comment">// The CN better have at least two dots if it wants wildcard</em>
<a class="jxr_linenumber" name="196" href="#196">196</a>             <em class="jxr_comment">// action.  It also can't be [*.co.uk] or [*.co.jp] or</em>
<a class="jxr_linenumber" name="197" href="#197">197</a>             <em class="jxr_comment">// [*.org.uk], etc...</em>
<a class="jxr_linenumber" name="198" href="#198">198</a>             String parts[] = cn.split(<span class="jxr_string">"&#92;&#92;."</span>);
<a class="jxr_linenumber" name="199" href="#199">199</a>             <strong class="jxr_keyword">boolean</strong> doWildcard = parts.length &gt;= 3 &amp;&amp;
<a class="jxr_linenumber" name="200" href="#200">200</a>                                  parts[0].endsWith(<span class="jxr_string">"*"</span>) &amp;&amp;
<a class="jxr_linenumber" name="201" href="#201">201</a>                                  acceptableCountryWildcard(cn) &amp;&amp;
<a class="jxr_linenumber" name="202" href="#202">202</a>                                  !isIPAddress(host);
<a class="jxr_linenumber" name="203" href="#203">203</a> 
<a class="jxr_linenumber" name="204" href="#204">204</a>             <strong class="jxr_keyword">if</strong>(doWildcard) {
<a class="jxr_linenumber" name="205" href="#205">205</a>                 String firstpart = parts[0];
<a class="jxr_linenumber" name="206" href="#206">206</a>                 <strong class="jxr_keyword">if</strong> (firstpart.length() &gt; 1) { <em class="jxr_comment">// e.g. server*</em>
<a class="jxr_linenumber" name="207" href="#207">207</a>                     String prefix = firstpart.substring(0, firstpart.length() - 1); <em class="jxr_comment">// e.g. server</em>
<a class="jxr_linenumber" name="208" href="#208">208</a>                     String suffix = cn.substring(firstpart.length()); <em class="jxr_comment">// skip wildcard part from cn</em>
<a class="jxr_linenumber" name="209" href="#209">209</a>                     String hostSuffix = hostName.substring(prefix.length()); <em class="jxr_comment">// skip wildcard part from host</em>
<a class="jxr_linenumber" name="210" href="#210">210</a>                     match = hostName.startsWith(prefix) &amp;&amp; hostSuffix.endsWith(suffix);
<a class="jxr_linenumber" name="211" href="#211">211</a>                 } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="212" href="#212">212</a>                     match = hostName.endsWith(cn.substring(1));
<a class="jxr_linenumber" name="213" href="#213">213</a>                 }
<a class="jxr_linenumber" name="214" href="#214">214</a>                 <strong class="jxr_keyword">if</strong>(match &amp;&amp; strictWithSubDomains) {
<a class="jxr_linenumber" name="215" href="#215">215</a>                     <em class="jxr_comment">// If we're in strict mode, then [*.foo.com] is not</em>
<a class="jxr_linenumber" name="216" href="#216">216</a>                     <em class="jxr_comment">// allowed to match [a.b.foo.com]</em>
<a class="jxr_linenumber" name="217" href="#217">217</a>                     match = countDots(hostName) == countDots(cn);
<a class="jxr_linenumber" name="218" href="#218">218</a>                 }
<a class="jxr_linenumber" name="219" href="#219">219</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="220" href="#220">220</a>                 match = hostName.equals(cn);
<a class="jxr_linenumber" name="221" href="#221">221</a>             }
<a class="jxr_linenumber" name="222" href="#222">222</a>             <strong class="jxr_keyword">if</strong>(match) {
<a class="jxr_linenumber" name="223" href="#223">223</a>                 <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="224" href="#224">224</a>             }
<a class="jxr_linenumber" name="225" href="#225">225</a>         }
<a class="jxr_linenumber" name="226" href="#226">226</a>         <strong class="jxr_keyword">if</strong>(!match) {
<a class="jxr_linenumber" name="227" href="#227">227</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> SSLException(<span class="jxr_string">"hostname in certificate didn't match: &lt;"</span> + host + <span class="jxr_string">"&gt; !="</span> + buf);
<a class="jxr_linenumber" name="228" href="#228">228</a>         }
<a class="jxr_linenumber" name="229" href="#229">229</a>     }
<a class="jxr_linenumber" name="230" href="#230">230</a> 
<a class="jxr_linenumber" name="231" href="#231">231</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> acceptableCountryWildcard(String cn) {
<a class="jxr_linenumber" name="232" href="#232">232</a>         String parts[] = cn.split(<span class="jxr_string">"&#92;&#92;."</span>);
<a class="jxr_linenumber" name="233" href="#233">233</a>         <strong class="jxr_keyword">if</strong> (parts.length != 3 || parts[2].length() != 2) {
<a class="jxr_linenumber" name="234" href="#234">234</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>; <em class="jxr_comment">// it's not an attempt to wildcard a 2TLD within a country code</em>
<a class="jxr_linenumber" name="235" href="#235">235</a>         }
<a class="jxr_linenumber" name="236" href="#236">236</a>         <strong class="jxr_keyword">return</strong> Arrays.binarySearch(BAD_COUNTRY_2LDS, parts[1]) &lt; 0;
<a class="jxr_linenumber" name="237" href="#237">237</a>     }
<a class="jxr_linenumber" name="238" href="#238">238</a> 
<a class="jxr_linenumber" name="239" href="#239">239</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String[] getCNs(X509Certificate cert) {
<a class="jxr_linenumber" name="240" href="#240">240</a>         LinkedList&lt;String&gt; cnList = <strong class="jxr_keyword">new</strong> LinkedList&lt;String&gt;();
<a class="jxr_linenumber" name="241" href="#241">241</a>         <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="242" href="#242">242</a> <em class="jxr_comment">          Sebastian Hauer's original StrictSSLProtocolSocketFactory used</em>
<a class="jxr_linenumber" name="243" href="#243">243</a> <em class="jxr_comment">          getName() and had the following comment:</em>
<a class="jxr_linenumber" name="244" href="#244">244</a> 
<a class="jxr_linenumber" name="245" href="#245">245</a> <em class="jxr_comment">                Parses a X.500 distinguished name for the value of the</em>
<a class="jxr_linenumber" name="246" href="#246">246</a> <em class="jxr_comment">                "Common Name" field.  This is done a bit sloppy right</em>
<a class="jxr_linenumber" name="247" href="#247">247</a> <em class="jxr_comment">                 now and should probably be done a bit more according to</em>
<a class="jxr_linenumber" name="248" href="#248">248</a> <em class="jxr_comment">                &lt;code&gt;RFC 2253&lt;/code&gt;.</em>
<a class="jxr_linenumber" name="249" href="#249">249</a> 
<a class="jxr_linenumber" name="250" href="#250">250</a> <em class="jxr_comment">           I've noticed that toString() seems to do a better job than</em>
<a class="jxr_linenumber" name="251" href="#251">251</a> <em class="jxr_comment">           getName() on these X500Principal objects, so I'm hoping that</em>
<a class="jxr_linenumber" name="252" href="#252">252</a> <em class="jxr_comment">           addresses Sebastian's concern.</em>
<a class="jxr_linenumber" name="253" href="#253">253</a> 
<a class="jxr_linenumber" name="254" href="#254">254</a> <em class="jxr_comment">           For example, getName() gives me this:</em>
<a class="jxr_linenumber" name="255" href="#255">255</a> <em class="jxr_comment">           1.2.840.113549.1.9.1=#16166a756c6975736461766965734063756362632e636f6d</em>
<a class="jxr_linenumber" name="256" href="#256">256</a> 
<a class="jxr_linenumber" name="257" href="#257">257</a> <em class="jxr_comment">           whereas toString() gives me this:</em>
<a class="jxr_linenumber" name="258" href="#258">258</a> <em class="jxr_comment">           EMAILADDRESS=juliusdavies@cucbc.com</em>
<a class="jxr_linenumber" name="259" href="#259">259</a> 
<a class="jxr_linenumber" name="260" href="#260">260</a> <em class="jxr_comment">           Looks like toString() even works with non-ascii domain names!</em>
<a class="jxr_linenumber" name="261" href="#261">261</a> <em class="jxr_comment">           I tested it with "&amp;#x82b1;&amp;#x5b50;.co.jp" and it worked fine.</em>
<a class="jxr_linenumber" name="262" href="#262">262</a> <em class="jxr_comment">        */</em>
<a class="jxr_linenumber" name="263" href="#263">263</a> 
<a class="jxr_linenumber" name="264" href="#264">264</a>         String subjectPrincipal = cert.getSubjectX500Principal().toString();
<a class="jxr_linenumber" name="265" href="#265">265</a>         StringTokenizer st = <strong class="jxr_keyword">new</strong> StringTokenizer(subjectPrincipal, <span class="jxr_string">","</span>);
<a class="jxr_linenumber" name="266" href="#266">266</a>         <strong class="jxr_keyword">while</strong>(st.hasMoreTokens()) {
<a class="jxr_linenumber" name="267" href="#267">267</a>             String tok = st.nextToken().trim();
<a class="jxr_linenumber" name="268" href="#268">268</a>             <strong class="jxr_keyword">if</strong> (tok.length() &gt; 3) {
<a class="jxr_linenumber" name="269" href="#269">269</a>                 <strong class="jxr_keyword">if</strong> (tok.substring(0, 3).equalsIgnoreCase(<span class="jxr_string">"CN="</span>)) {
<a class="jxr_linenumber" name="270" href="#270">270</a>                     cnList.add(tok.substring(3));
<a class="jxr_linenumber" name="271" href="#271">271</a>                 }
<a class="jxr_linenumber" name="272" href="#272">272</a>             }
<a class="jxr_linenumber" name="273" href="#273">273</a>         }
<a class="jxr_linenumber" name="274" href="#274">274</a>         <strong class="jxr_keyword">if</strong>(!cnList.isEmpty()) {
<a class="jxr_linenumber" name="275" href="#275">275</a>             String[] cns = <strong class="jxr_keyword">new</strong> String[cnList.size()];
<a class="jxr_linenumber" name="276" href="#276">276</a>             cnList.toArray(cns);
<a class="jxr_linenumber" name="277" href="#277">277</a>             <strong class="jxr_keyword">return</strong> cns;
<a class="jxr_linenumber" name="278" href="#278">278</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="279" href="#279">279</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="280" href="#280">280</a>         }
<a class="jxr_linenumber" name="281" href="#281">281</a>     }
<a class="jxr_linenumber" name="282" href="#282">282</a> 
<a class="jxr_linenumber" name="283" href="#283">283</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="284" href="#284">284</a> <em class="jxr_javadoccomment">     * Extracts the array of SubjectAlt DNS or IP names from an X509Certificate.</em>
<a class="jxr_linenumber" name="285" href="#285">285</a> <em class="jxr_javadoccomment">     * Returns null if there aren't any.</em>
<a class="jxr_linenumber" name="286" href="#286">286</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="287" href="#287">287</a> <em class="jxr_javadoccomment">     * @param cert X509Certificate</em>
<a class="jxr_linenumber" name="288" href="#288">288</a> <em class="jxr_javadoccomment">     * @param hostname</em>
<a class="jxr_linenumber" name="289" href="#289">289</a> <em class="jxr_javadoccomment">     * @return Array of SubjectALT DNS or IP names stored in the certificate.</em>
<a class="jxr_linenumber" name="290" href="#290">290</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="291" href="#291">291</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> String[] getSubjectAlts(
<a class="jxr_linenumber" name="292" href="#292">292</a>             <strong class="jxr_keyword">final</strong> X509Certificate cert, <strong class="jxr_keyword">final</strong> String hostname) {
<a class="jxr_linenumber" name="293" href="#293">293</a>         <strong class="jxr_keyword">int</strong> subjectType;
<a class="jxr_linenumber" name="294" href="#294">294</a>         <strong class="jxr_keyword">if</strong> (isIPAddress(hostname)) {
<a class="jxr_linenumber" name="295" href="#295">295</a>             subjectType = 7;
<a class="jxr_linenumber" name="296" href="#296">296</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="297" href="#297">297</a>             subjectType = 2;
<a class="jxr_linenumber" name="298" href="#298">298</a>         }
<a class="jxr_linenumber" name="299" href="#299">299</a> 
<a class="jxr_linenumber" name="300" href="#300">300</a>         LinkedList&lt;String&gt; subjectAltList = <strong class="jxr_keyword">new</strong> LinkedList&lt;String&gt;();
<a class="jxr_linenumber" name="301" href="#301">301</a>         Collection&lt;List&lt;?&gt;&gt; c = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="302" href="#302">302</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="303" href="#303">303</a>             c = cert.getSubjectAlternativeNames();
<a class="jxr_linenumber" name="304" href="#304">304</a>         }
<a class="jxr_linenumber" name="305" href="#305">305</a>         <strong class="jxr_keyword">catch</strong>(CertificateParsingException cpe) {
<a class="jxr_linenumber" name="306" href="#306">306</a>         }
<a class="jxr_linenumber" name="307" href="#307">307</a>         <strong class="jxr_keyword">if</strong>(c != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="308" href="#308">308</a>             <strong class="jxr_keyword">for</strong> (List&lt;?&gt; aC : c) {
<a class="jxr_linenumber" name="309" href="#309">309</a>                 List&lt;?&gt; list = aC;
<a class="jxr_linenumber" name="310" href="#310">310</a>                 <strong class="jxr_keyword">int</strong> type = ((Integer) list.get(0)).intValue();
<a class="jxr_linenumber" name="311" href="#311">311</a>                 <strong class="jxr_keyword">if</strong> (type == subjectType) {
<a class="jxr_linenumber" name="312" href="#312">312</a>                     String s = (String) list.get(1);
<a class="jxr_linenumber" name="313" href="#313">313</a>                     subjectAltList.add(s);
<a class="jxr_linenumber" name="314" href="#314">314</a>                 }
<a class="jxr_linenumber" name="315" href="#315">315</a>             }
<a class="jxr_linenumber" name="316" href="#316">316</a>         }
<a class="jxr_linenumber" name="317" href="#317">317</a>         <strong class="jxr_keyword">if</strong>(!subjectAltList.isEmpty()) {
<a class="jxr_linenumber" name="318" href="#318">318</a>             String[] subjectAlts = <strong class="jxr_keyword">new</strong> String[subjectAltList.size()];
<a class="jxr_linenumber" name="319" href="#319">319</a>             subjectAltList.toArray(subjectAlts);
<a class="jxr_linenumber" name="320" href="#320">320</a>             <strong class="jxr_keyword">return</strong> subjectAlts;
<a class="jxr_linenumber" name="321" href="#321">321</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="322" href="#322">322</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="323" href="#323">323</a>         }
<a class="jxr_linenumber" name="324" href="#324">324</a>     }
<a class="jxr_linenumber" name="325" href="#325">325</a> 
<a class="jxr_linenumber" name="326" href="#326">326</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="327" href="#327">327</a> <em class="jxr_javadoccomment">     * Extracts the array of SubjectAlt DNS names from an X509Certificate.</em>
<a class="jxr_linenumber" name="328" href="#328">328</a> <em class="jxr_javadoccomment">     * Returns null if there aren't any.</em>
<a class="jxr_linenumber" name="329" href="#329">329</a> <em class="jxr_javadoccomment">     * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="330" href="#330">330</a> <em class="jxr_javadoccomment">     * Note:  Java doesn't appear able to extract international characters</em>
<a class="jxr_linenumber" name="331" href="#331">331</a> <em class="jxr_javadoccomment">     * from the SubjectAlts.  It can only extract international characters</em>
<a class="jxr_linenumber" name="332" href="#332">332</a> <em class="jxr_javadoccomment">     * from the CN field.</em>
<a class="jxr_linenumber" name="333" href="#333">333</a> <em class="jxr_javadoccomment">     * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="334" href="#334">334</a> <em class="jxr_javadoccomment">     * (Or maybe the version of OpenSSL I'm using to test isn't storing the</em>
<a class="jxr_linenumber" name="335" href="#335">335</a> <em class="jxr_javadoccomment">     * international characters correctly in the SubjectAlts?).</em>
<a class="jxr_linenumber" name="336" href="#336">336</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="337" href="#337">337</a> <em class="jxr_javadoccomment">     * @param cert X509Certificate</em>
<a class="jxr_linenumber" name="338" href="#338">338</a> <em class="jxr_javadoccomment">     * @return Array of SubjectALT DNS names stored in the certificate.</em>
<a class="jxr_linenumber" name="339" href="#339">339</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="340" href="#340">340</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String[] getDNSSubjectAlts(X509Certificate cert) {
<a class="jxr_linenumber" name="341" href="#341">341</a>         <strong class="jxr_keyword">return</strong> getSubjectAlts(cert, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="342" href="#342">342</a>     }
<a class="jxr_linenumber" name="343" href="#343">343</a> 
<a class="jxr_linenumber" name="344" href="#344">344</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="345" href="#345">345</a> <em class="jxr_javadoccomment">     * Counts the number of dots "." in a string.</em>
<a class="jxr_linenumber" name="346" href="#346">346</a> <em class="jxr_javadoccomment">     * @param s  string to count dots from</em>
<a class="jxr_linenumber" name="347" href="#347">347</a> <em class="jxr_javadoccomment">     * @return  number of dots</em>
<a class="jxr_linenumber" name="348" href="#348">348</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="349" href="#349">349</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">int</strong> countDots(<strong class="jxr_keyword">final</strong> String s) {
<a class="jxr_linenumber" name="350" href="#350">350</a>         <strong class="jxr_keyword">int</strong> count = 0;
<a class="jxr_linenumber" name="351" href="#351">351</a>         <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">int</strong> i = 0; i &lt; s.length(); i++) {
<a class="jxr_linenumber" name="352" href="#352">352</a>             <strong class="jxr_keyword">if</strong>(s.charAt(i) == '.') {
<a class="jxr_linenumber" name="353" href="#353">353</a>                 count++;
<a class="jxr_linenumber" name="354" href="#354">354</a>             }
<a class="jxr_linenumber" name="355" href="#355">355</a>         }
<a class="jxr_linenumber" name="356" href="#356">356</a>         <strong class="jxr_keyword">return</strong> count;
<a class="jxr_linenumber" name="357" href="#357">357</a>     }
<a class="jxr_linenumber" name="358" href="#358">358</a> 
<a class="jxr_linenumber" name="359" href="#359">359</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> isIPAddress(<strong class="jxr_keyword">final</strong> String hostname) {
<a class="jxr_linenumber" name="360" href="#360">360</a>         <strong class="jxr_keyword">return</strong> hostname != <strong class="jxr_keyword">null</strong> &amp;&amp;
<a class="jxr_linenumber" name="361" href="#361">361</a>             (InetAddressUtils.isIPv4Address(hostname) ||
<a class="jxr_linenumber" name="362" href="#362">362</a>                     InetAddressUtils.isIPv6Address(hostname));
<a class="jxr_linenumber" name="363" href="#363">363</a>     }
<a class="jxr_linenumber" name="364" href="#364">364</a> 
<a class="jxr_linenumber" name="365" href="#365">365</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

